# THIS FILE IS AUTOMATICALLY GENERATED BY CARGO
#
# When uploading crates to the registry Cargo will automatically
# "normalize" Cargo.toml files for maximal compatibility
# with all versions of Cargo and also rewrite `path` dependencies
# to registry (e.g., crates.io) dependencies.
#
# If you are reading this file be aware that the original Cargo.toml
# will likely look very different (and much more reasonable).
# See Cargo.toml.orig for the original contents.

[package]
edition = "2024"
name = "blue-build"
version = "0.9.12"
build = "build.rs"
autolib = false
autobins = false
autoexamples = false
autotests = false
autobenches = false
description = "A CLI tool built for creating Containerfile templates for ostree based atomic distros"
readme = "README.md"
license = "Apache-2.0"
repository = "https://github.com/blue-build/cli"

[package.metadata.release]
pre-release-hook = [
    "git",
    "cliff",
    "-o",
    "CHANGELOG.md",
    "--tag",
    "{{version}}",
]

[[package.metadata.release.pre-release-replacements]]
file = "install.sh"
replace = "VERSION=v{{version}}"
search = 'VERSION=v\d+\.\d+\.\d+'

[[package.metadata.release.pre-release-replacements]]
file = "flake.nix"
replace = 'version = "v{{version}}";'
search = 'version = "v\d+\.\d+\.\d+";'

[features]
copy = ["blue-build-recipe/copy"]
default = ["v0_9_0"]
init = []
iso = []
login = []
multi-recipe = [
    "dep:rayon",
    "indicatif/rayon",
]
prune = ["blue-build-process-management/prune"]
rechunk = ["blue-build-process-management/rechunk"]
sigstore = ["blue-build-process-management/sigstore"]
stages = ["blue-build-recipe/stages"]
switch = []
v0_9_0 = [
    "init",
    "stages",
    "copy",
    "iso",
    "switch",
    "login",
    "validate",
    "sigstore",
    "multi-recipe",
    "prune",
    "rechunk",
]
validate = [
    "dep:jsonschema",
    "dep:rayon",
    "dep:tokio",
    "dep:yaml-rust2",
    "dep:syntect",
    "dep:regex",
    "cached/async",
    "blue-build-process-management/validate",
]

[lib]
name = "blue_build"
path = "src/lib.rs"

[[bin]]
name = "bluebuild"
path = "src/bin/bluebuild.rs"

[dependencies.blue-build-process-management]
version = "=0.9.12"

[dependencies.blue-build-recipe]
version = "=0.9.12"

[dependencies.blue-build-template]
version = "=0.9.12"

[dependencies.blue-build-utils]
version = "=0.9.12"

[dependencies.bon]
version = "3"

[dependencies.cached]
version = "0.55"

[dependencies.clap]
version = "4"
features = [
    "derive",
    "cargo",
    "unicode",
    "env",
]

[dependencies.clap-verbosity-flag]
version = "3"

[dependencies.clap_complete]
version = "4"

[dependencies.clap_complete_nushell]
version = "4"

[dependencies.colored]
version = "2"

[dependencies.comlexr]
version = "1"

[dependencies.fuzzy-matcher]
version = "0.3"

[dependencies.indexmap]
version = "2"
features = ["serde"]

[dependencies.indicatif]
version = "0.17"
features = ["improved_unicode"]

[dependencies.jsonschema]
version = "0.30"
optional = true

[dependencies.log]
version = "0.4"

[dependencies.miette]
version = "7"
features = ["fancy"]

[dependencies.oci-distribution]
version = "0.11"
default-features = false

[dependencies.open]
version = "5"

[dependencies.os_info]
version = "3"

[dependencies.rayon]
version = "1"
optional = true

[dependencies.regex]
version = "1"
optional = true

[dependencies.requestty]
version = "0.5"
features = [
    "macros",
    "termion",
]

[dependencies.reqwest]
version = "0.12"
features = ["rustls-tls"]
default-features = false

[dependencies.semver]
version = "1"

[dependencies.serde]
version = "1"
features = ["derive"]

[dependencies.serde_json]
version = "1"

[dependencies.serde_yaml]
version = "0.0.12"
package = "serde_yml"

[dependencies.shadow-rs]
version = "1"
default-features = false

[dependencies.syntect]
version = "5"
features = ["default-fancy"]
optional = true
default-features = false

[dependencies.tempfile]
version = "3"

[dependencies.thiserror]
version = "2"

[dependencies.tokio]
version = "1"
features = [
    "rt",
    "rt-multi-thread",
]
optional = true

[dependencies.urlencoding]
version = "2"

[dependencies.users]
version = "0.11"

[dependencies.yaml-rust2]
version = "0.10"
optional = true

[dev-dependencies.rstest]
version = "0.18"

[dev-dependencies.rusty-hook]
version = "0.11"

[build-dependencies.shadow-rs]
version = "1"

[lints.clippy]
correctness = "deny"
nursery = "deny"
pedantic = "deny"
perf = "deny"
style = "deny"
suspicious = "deny"

[lints.clippy.doc_markdown]
level = "allow"
priority = 1

[lints.clippy.module_name_repetitions]
level = "allow"
priority = 1

[lints.rust]
unsafe_code = "forbid"

[profile.release]
lto = true
codegen-units = 1
debug = 0
panic = "abort"
strip = "none"
